﻿using UnityEngine;
using System.Collections;

public class BallScript : MonoBehaviour {
	private PaddleScript paddle;

	public Sprite[] Balls;
	internal bool isGameStarted;
	public AudioClip startAudio;
	// Use this for initialization
	void Awake () {
		ChangeBallUI ();
	}
	void Start () {
		isGameStarted = false;
		paddle = Object.FindObjectOfType<PaddleScript> ();

	}
	
	// Update is called once per frame
	void Update () {
		if (!isGameStarted) {

			// lock the paddle to the ball
			Vector3 vecDistance = new Vector3 (paddle.transform.position.x , paddle.transform.position.y + 0.33f);
			this.transform.position = vecDistance;

			// start velocity by pressing left mouse button
			if (Input.GetMouseButtonDown (0))
			{
				AudioSource.PlayClipAtPoint(startAudio, transform.position, 0.2f);
				this.rigidbody2D.velocity = new Vector2 (0.2f, 12f);

				isGameStarted = true;
			}
		}

		// fix the boring loop
		float ballVelocity = GetComponent<Rigidbody2D>().velocity.magnitude;
		if (ballVelocity <= 7)
		{
			GetComponent<Rigidbody2D>().velocity = GetComponent<Rigidbody2D>().velocity.normalized * 7;
		}
		else if (ballVelocity >= 12)
		{
			GetComponent<Rigidbody2D>().velocity = GetComponent<Rigidbody2D>().velocity.normalized * 12;
		}
	}

	void OnCollisionEnter2D(Collision2D coll)
	{
		//Vector2 tweak = new Vector2(Random.Range(0f, 0.2f), Random.Range(0f, 0.2f));
		//this.rigidbody2D.velocity += tweak;// = new Vector2 (0.2f, 12f);

		//if (isGameStarted)
		//	audio.Play ();
	}

	void ChangeBallUI()
	{
		int ballRndNum = Random.Range (0, 25);
		Sprite rndBallSprite = Balls [ballRndNum];
		GetComponent<SpriteRenderer> ().sprite = rndBallSprite;

	}
}
