﻿using UnityEngine;
using System.Collections;

public class BrickScript : MonoBehaviour {

	public AudioClip brickHit;
	public AudioClip brickExplode;


	public Sprite[] hitBricks;
	public LevelManagerScript levelManager;
	public static int breakableCount;
	public GameObject smoke;
	public Color smokeColor;

	private int totalHits;
	private bool isBreakable;

	// Use this for initialization
	void Start () {
		levelManager = GameObject.FindObjectOfType<LevelManagerScript>();
		totalHits = 0;
		isBreakable = this.tag == "Breakable";

		if (isBreakable)
			breakableCount++;
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnCollisionExit2D(Collision2D coll)
	{
		print (breakableCount);
		if (!isBreakable) {
			AudioSource.PlayClipAtPoint (brickHit, transform.position, 0.2f);
			return;
		}


		totalHits++;
		//print (totalHits);
		if (totalHits >= hitBricks.Length) {
			AudioSource.PlayClipAtPoint (brickExplode, transform.position, 0.2f);
			breakableCount--;
			InstantiateSmoke ();
			Destroy (gameObject);
			levelManager.BrickDestroyed ();
		} else {
			AudioSource.PlayClipAtPoint (brickHit, transform.position, 0.2f);
			LoadSprites ();
		}

	}

	void InstantiateSmoke()
	{

		GameObject smokePuff = Instantiate (smoke, this.gameObject.transform.position, Quaternion.identity) as GameObject;
		smokePuff.particleSystem.startColor = smokeColor;

	}

	void LoadSprites() 
	{
		if (hitBricks [totalHits] != null)
			this.GetComponent<SpriteRenderer>().sprite = hitBricks [totalHits];
	}

}

